#include "beispiele.h"

unsigned long int factorial(unsigned int x){
  return  x <= 1 ? 1 : x* factorial(x-1);
}

int mystery(int x, int z){
  if (x==0) return 0;
  if (x<0) return mystery(-x,-z);
  return mystery(x-1,z) + z;
}

unsigned int ggt(unsigned int a, unsigned int b){
  if (a == 0) return b;
  if (b == 0) return a;
  if (a > b)  return ggt(a % b,b);
  return ggt(a,b % a);
}

void eratosthenes(bool* array, unsigned int length){
  unsigned int i, j;
  for (i = 0; i< length;i++){
    array[i] = true;
  }
  for (i = 0; i< length;i++){
    if (array[i]){
      for (j = i+i+2; j < length;j+=i+2){
        array[j] = false;
      }
    }
  }
}

void matrixMult(double** a,double** b,double** c,unsigned int n){
  unsigned int i, j, k;
  for (i=0;i<n;i++){
    for (j=0;j<n;j++){
      c[i][j] = 0;
      for (k=0;k<n;k++){
	c[i][j] += a[i][k] * b[k][j];
      }
    }
  }
}
